//if using any custom parameters, note them here what they're used for
// eg. param 1: sets font size

(function () {
	window.bazingaApp.views.abstractModuleView = window.bazingaApp.views.appView.extend({

		beforePageLoad: function () {
			var self = this;
			
			pageNum = parseInt(self.getQueryVariable("p")) || 1;
			window.bazingaApp.models.navigation.setParam4(pageNum);
			
			$( ".pageBlock" ).each(function() {
				var thisPageNum = $(this).attr("data-pageNum");
				console.log(thisPageNum+"/"+pageNum);
				if(parseInt(thisPageNum) <= pageNum){
					$(this).show();
					$(window).trigger('resize');
					console.log("show "+thisPageNum);
				}
			});
			
			$(".nextQuestionBtn").click(function() {
				
				var newIndicator = $(this).parents(".multiContainer").find(".activeIndicator").next();
				$(this).parents(".multiContainer").find(".questionIndicator li").removeClass("activeIndicator");
				newIndicator.addClass("activeIndicator");
				
			});
			
			//true false question 2-9

            /*if($(".pairBtn").length > 0){
                $(".pairBtn").on('click touchend',function() { //need the touchend for ipad

                    console.log("test");

                    var pairFeedback= '<span class="pairFeedback">That’s right.</span> ';

                    if($(this).find('.icon-tick[src$="../img/tick.png"]').length == 0){
                        //console.log("wrong");
                        pairFeedback= '<span class="pairFeedback">That’s not the best answer.</span> ';
                    }

                    var overlay = $($(this).attr("data-reveal-data"));

                    overlay.find('.pairFeedback').remove();
                    overlay.find("h3").prepend(pairFeedback);

                });
            }*/

			self.updatePrompt();
			self.updateProgress();
			var scrolling = false;
			
			var containerWidth = $("#containers .container").outerWidth();
			var numContainers = $("#containers .container").length;
			var numVisibleContainers = $("#containers .container:visible").length;
			
			//if part of a multi page, reduce until get to first page
			if($( ".pageBlock:visible" ).last().hasClass("partBlock")){
				console.log("part of block");
				var partOf = $( ".pageBlock:visible" ).last().attr("data-pageNum");
				console.log(partOf);
				numVisibleContainers = numVisibleContainers - ($("#containers .container:visible[data-pageNum="+partOf+"]").length-1);
			}
			
			var scrollSpeed = 100;
			var scrollTime = 0;
			
			if( $( ".pageBlock:not(.partBlock):visible" ).last().find("audio").length > 0){
				$( ".pageBlock:not(.partBlock):visible" ).last().find("audio")[0].play();
			}
			
			//update containers width
			$("#containers").css("width",(containerWidth+5)*numContainers);
			
			//default scroll
			$("#containers").css("margin-left",-containerWidth*(numVisibleContainers-1));
			
			//detect scroll
			$('body').on( 'DOMMouseScroll mousewheel', function ( event ) {
				
				var numVisibleContainers = $("#containers .container:visible").length;
				var currentLeft = parseInt($("#containers").css("margin-left").slice(0,-2));
				
				if(!scrolling){
			  if( event.originalEvent.detail > 0 || event.originalEvent.wheelDelta < 0 ) { //alternative options for wheelData: wheelDeltaX & wheelDeltaY
				//scroll down
				  
				  //console.log(currentLeft);
				  
				  if(currentLeft > -(numVisibleContainers-1)*containerWidth){
					//console.log('down, go right');
					  scrolling = true;
					  
					  //console.log((currentLeft-scrollSpeed)+"/"+(-containerWidth*numContainers));
					  
					  if(currentLeft-scrollSpeed < -containerWidth*(numVisibleContainers-1)){ 
						 //console.log("too much");
						  $("#containers").animate({marginLeft: -containerWidth*(numVisibleContainers-1)},scrollTime,function(){scrolling = false;});
						  
						  //play audio if pageBlock has audio
						  try {
						//console.log("autoplay audio");
							  var currentPageBlock = $( ".pageBlock:visible" ).last();
						//currentPageBlock.css({'height': "auto"});
				
						var currentPageNum = currentPageBlock.attr("data-pageNum");
						$("[data-pageNum="+currentPageNum +"] audio")[0].play();
							  
					  self.updatePrompt();
							  
					}
					catch(err) {
    					console.log("no audio");
						
					  self.updatePrompt();
						}
						  
					  }else{
						  //console.log("ok");
				  		$("#containers").animate({marginLeft: currentLeft-scrollSpeed},scrollTime,function(){scrolling = false;});
					  }
				  }
			  } else {
				//scroll up
				  
				  if(currentLeft < 0){
					   scrolling = true;
					  if(currentLeft + scrollSpeed > 0){
				  $("#containers").animate({marginLeft: 0},scrollTime,function(){scrolling = false;});
					  }else {
						//console.log('Up');
						  scrolling = true;
				  $("#containers").animate({marginLeft: currentLeft+scrollSpeed},scrollTime,function(){scrolling = false;});
				  }
				  
			  }
				}
				}
			  //prevent page fom scrolling
			  return false;
			});
			
			$(".finishScroll").bind('ended', function(){
				// done playing
				console.log("audio finished");
				//$( "#nextPageBlock" ).trigger( "click" );
				self.updatePrompt("scroll");
				self.updateScroll();
			});
			
			$(".clickScroll").click(function() {
				if(!$(this).hasClass("is-disabled") || $(this).hasClass("is-submitted")){
				self.updatePrompt("scroll");
				self.updateScroll();
				}
			});
			
			$(".completeTopicBtn").click(function() {
				if(!$(this).hasClass("is-disabled")){
					$(".nextBtn").removeClass("is-disabled").show();
				}
			});
			
		},

		beforeAbstractLoad: function () {
			
		},
		
		updatePrompt:function(keyword){
			$("#promptText").addClass("fade-in-bottom");
			
			if(keyword == "scroll"){
				$("#promptText").html("Scroll to continue");
			}else{
			
				var currentPageBlock = $( ".pageBlock:visible" ).last();
				if(currentPageBlock.hasClass("mcPage")){
					$("#promptText").html("Select the correct answer(s), then click Submit.");
				}else{
					//just audio
					$("#promptText").html("Listen to the audio");
				}
			}
			
			setTimeout(function(){$("#promptText").removeClass("fade-in-bottom");},2000);
			
		},
		
		updateScroll:function(){
			console.log("update scroll");
			$('audio').each(function(){
					this.pause(); // Stop playing
					if(this.currentTime){
					this.currentTime = 0; // Reset time
					}
				});
			
			var currentPageBlock = $( ".pageBlock:visible" ).last();
				console.log("prev page block num: "+currentPageBlock.attr("data-pageNum"));
				//currentPageBlock.css({'height': "auto"});
			
			//if has topicComplete btn, trigger it
			if(currentPageBlock.find(".completeTopicBtn.u-hidden").length > 0){
				$(".completeTopicBtn").trigger( "click");
			}
				
				//complete the section you were on
				var preId = $("body").attr("data-pre-id");
				var prevPageNum = currentPageBlock.attr("data-pageNum");
				var pageId = parseInt(preId + prevPageNum);
				console.log("complete page: "+pageId);
				window.bazingaApp.models.navigation.setPageCompletion("completed",pageId);
			
			var newCurrentPageBlock = currentPageBlock.next();
			
			/*if(newCurrentPageBlock.attr("data-pageNum") == undefined){
						console.log("no pageNum, revert to old pageBlock");
						newCurrentPageBlock = currentPageBlock;
				};*/
			
			//newCurrentPageBlock = $( ".pageBlock:visible" ).last();
			newCurrentPageBlock.show();
			
			//console.log("check partblock");
			if($( ".pageBlock:visible" ).last().hasClass("partBlock")){
				var samePart = $( ".pageBlock:visible" ).last().attr("data-pageNum");
				//console.log("samePart "+samePart);
				$("[data-pageNum="+samePart+"]").show();
				
				//reshow next
				var newCurrentPageBlock = $( ".pageBlock:visible" ).last().next();
				newCurrentPageBlock.show();
			}
			
			$(window).trigger('resize');
			
			var currentPageNum = newCurrentPageBlock.attr("data-pageNum");
				
				var newPageId = parseInt(preId + currentPageNum);
				window.bazingaApp.models.api.setLessonLocation(newPageId); //set current page to new section that you scrolled to
				
				console.log("new currentPageNum "+currentPageNum);
				
				window.bazingaApp.models.navigation.setParam4(currentPageNum);
				console.log("p4 is now: "+window.bazingaApp.models.navigation.getParam4());
			self = this;
			self.updateProgress();
			
		},
		
		updateProgress:function(){
			var completedTopicPages = window.bazingaApp.models.api.getAllCompletedTopicPagesNum();
			var allTopicPages = window.bazingaApp.models.api.getAllTopicPagesNum();
			var progress = (completedTopicPages/allTopicPages)*100; 
			console.log(progress);
			$( "#progress" ).animate({width:progress+"%"});
		},
		
		getQueryVariable: function (variable) {
                var query = window.location.search.substring(1);
                var vars = query.split("&");
                for (var i = 0; i < vars.length; i++) {
                    var pair = vars[i].split("=");
                    if (pair[0] == variable) {
                        return pair[1];
                    }
                }
                return (false);
            },

		abstractLoads: function () {
			console.log("-----------------------------");
			//window.bazingaApp.models.navigation.setInfo('name','something');
			//console.log(window.bazingaApp.models.navigation.getInfo('name'));
			
		}
				
	});
}());
